import { world, system } from "@minecraft/server";

system.events.beforeWatchdogTerminate.subscribe(data => {
    data.cancel = true;
});

let dynamicfog0IsActive = false;
let dynamicfog1IsActive = false;
let dynamicfog2IsActive = false;
let dynamicfog3IsActive = false;
let dynamicfog4IsActive = false;
let dynamicfog5IsActive = false;
let dynamicfog6IsActive = false;
let dynamicfog7IsActive = false;
let dynamicfog8IsActive = false;

system.run(tickFunction);

function tickFunction() {
    //let w = world.getDimension("overworld");
    let t = world.getTime();

    for (let p of world.getPlayers()) {

        //world.sendMessage(`Time: ${t}`);

        if (t >= 23100 || t >= 0 && t < 200) {
            if (dynamicfog0IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog" "dynamicfog"`);
                dynamicfog0IsActive = true;
                //world.sendMessage(`dynamicfog0 Is Active`);
            }
        }
        else if (dynamicfog0IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog"`);
            dynamicfog0IsActive = false;
            //world.sendMessage(`dynamicfog0 Is Deactive`);
        }

        if (t >= 22990 && t < 23100 || t >= 200 && t < 450) {
            if (dynamicfog1IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog1" "dynamicfog1"`);
                dynamicfog1IsActive = true;
            }
        }
        else if (dynamicfog1IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog1"`);
            dynamicfog1IsActive = false;
        }

        if (t >= 22850 && t < 22990 || t >= 450 && t < 700) {
            if (dynamicfog2IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog2" "dynamicfog2"`);
                dynamicfog2IsActive = true;
            }
        }
        else if (dynamicfog2IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog2"`);
            dynamicfog2IsActive = false;
        }

        if (t >= 22720 && t < 22850 || t >= 700 && t < 900) {
            if (dynamicfog3IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog3" "dynamicfog3"`);
                dynamicfog3IsActive = true;
            }
        }
        else if (dynamicfog3IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog3"`);
            dynamicfog3IsActive = false;
        }

        if (t >= 22600 && t < 22720 || t >= 900 && t < 1200) {
            if (dynamicfog4IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog4" "dynamicfog4"`);
                dynamicfog4IsActive = true;
            }
        }
        else if (dynamicfog4IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog4"`);
            dynamicfog4IsActive = false;
        }

        if (t >= 22480 && t < 22600 || t > 1200 && t <= 1450) {
            if (dynamicfog5IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog5" "dynamicfog5"`);
                dynamicfog5IsActive = true;
            }
        }
        else if (dynamicfog5IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog5"`);
            dynamicfog5IsActive = false;
        }

        if (t >= 22350 && t < 22480 || t > 1450 && t <= 1700) {
            if (dynamicfog6IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog6" "dynamicfog6"`);
                dynamicfog6IsActive = true;
            }
        }
        else if (dynamicfog6IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog6"`);
            dynamicfog6IsActive = false;
        }

        if (t >= 22220 && t < 22350 || t > 1700 && t <= 1950) {
            if (dynamicfog7IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog7" "dynamicfog7"`);
                dynamicfog7IsActive = true;
            }
        }
        else if (dynamicfog7IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog7"`);
            dynamicfog7IsActive = false;
        }

        if (t >= 22100 && t < 22220 || t > 1950 && t <= 2200) {
            if (dynamicfog8IsActive == false) {
                p.runCommandAsync(`fog @s push "df:dynamic_fog8" "dynamicfog8"`);
                dynamicfog8IsActive = true;
            }
        }
        else if (dynamicfog8IsActive == true) {
            p.runCommandAsync(`fog @s remove "dynamicfog8"`);
            dynamicfog8IsActive = false;
        }
    }
    system.run(tickFunction);
}